//----------------------------------------------------------------------------
// Copyright (c) 1997 by Joseph Parrello. All Rights Reserved.
// Site   : http://space.tin.it/computer/giparrel
// E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it
//
// Revision:   1.1  (December 26,1997).
//
// Definition of JPMenuGadget class.
//
// Read README.TXT for use and license.
//
// Only for OWL 5.02 users.
// OWL and ObjectWindows are trademarks of Borland International.
//
// THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//----------------------------------------------------------------------------

#if !defined(jpmenuga_h)
#define jpmenuga_h

#if !defined(OWL_TEXTGADG_H)
#include <owl/textgadg.h>
#endif
#if !defined(OWL_MENU_H)
# include <owl/menu.h>
#endif
#if !defined(OWL_GADGETWI_H)
#include <owl/gadgetwi.h>
#endif

//{{TTextGadget = JPMenuGadget}}
class JPMenuGadget : public TTextGadget {
  public:
    JPMenuGadget(TMenu& menu, TWindow* window, int id = 0, TBorderStyle = Recessed, const char far* text = 0, TAlign = Left, uint numChars = 15, TFont* font = 0 );
    virtual ~JPMenuGadget();

  private:
    TPopupMenu*         GadgetPopupMenu;
    TWindow*            MenuTarget;
    TBorderStyle        DefaultBorderStyle;
    HWND                ParentWnd;
#if defined(BI_PLAT_WIN32)
    bool                TrackPopupMenuEx(uint flags, const TPoint& point, HWND wnd, const TRect* rect);
#endif

//{{JPMenuGadgetVIRTUAL_BEGIN}}
  public:
    virtual void LButtonDown(uint modKeys, TPoint& point);
    virtual void MouseEnter(uint modKeys, TPoint& point);
    virtual void MouseLeave(uint modKeys, TPoint& point);
//{{JPMenuGadgetVIRTUAL_END}}
};    //{{JPMenuGadget}}

#endif
